﻿using Syncfusion.Drawing;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Parsing;
using System;
using System.IO;

namespace ConsoleAppCore
{
    class Program
    {

        public static string DataPathBase
        {
            get
            {

                return System.Environment.CurrentDirectory + @"\..\..\..\Data\";

            }
        }
        public static string DataPathOutput
        {
            get
            {
                if (!System.IO.Directory.Exists(System.Environment.CurrentDirectory + @"\..\..\..\Output\"))
                    System.IO.Directory.CreateDirectory(System.Environment.CurrentDirectory + @"\..\..\..\Output\");
                return System.Environment.CurrentDirectory + @"\..\..\..\Output\";
            }
        }

        static void Main(string[] args)
        {
            Split_ImportPage();
            Split_ImportPageRange();
            
        }

        private static void Split_ImportPageRange()
        {
            //Load the PDF document.
            FileStream docStream = new FileStream(DataPathBase + "Sample.pdf", FileMode.Open, FileAccess.Read);

            //Load the PDF document.
            PdfLoadedDocument lDoc = new PdfLoadedDocument(docStream);

            int count = lDoc.PageCount;

            for (int i = 0; i < count; i++)
            {
                //Creates a new document
                PdfDocument document = new PdfDocument();

                //Imports the range of pages in selected index

                document.ImportPageRange(lDoc, i, i);

                MemoryStream ms = new MemoryStream();
                //Save the document
                document.Save(ms);

                using (var fileStream = File.Create(DataPathOutput + "Split" + i + ".pdf"))
                {
                    ms.Seek(0, SeekOrigin.Begin);
                    ms.CopyTo(fileStream);
                }
                //Close the document
                document.Close(true);
            }


        }

        private static void Split_ImportPage()
        {
            //Load the PDF document.
            FileStream docStream = new FileStream(DataPathBase + "Sample.pdf", FileMode.Open, FileAccess.Read);

            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(docStream);

            for (int i = 0; i < loadedDocument.PageCount; i++)
            {

                //Creates a new document

                PdfDocument document = new PdfDocument();

                //Imports the pages from the loaded document

                document.ImportPage(loadedDocument, i);

                //Create a memory stream 

                MemoryStream stream = new MemoryStream();

                //Save the document to stream

                document.Save(stream);

                stream.Position = 0;

                //Close the document

                document.Close(true);

                //Create a file stream

                FileStream fileStream = new FileStream(DataPathOutput + "ImportPage_Output" + i + ".pdf", FileMode.Create, FileAccess.Write);

                byte[] bytes = stream.ToArray();

                //Write bytes to file

                fileStream.Write(bytes, 0, (int)bytes.Length);

                //Dispose the streams

                stream.Dispose();

                fileStream.Dispose();

            }

        }
    }
}
